create or replace package PKG_P8PANELS_RRPCONFED as

  /*     */
  procedure INSERT_RRPCONF_SECTIONS
  (
    NPRN                    in number,   -- .    
    SCODE                   in varchar2, -- 
    SNAME                   in varchar2, -- 
    NRN                     out number   -- .  
  );
  
  /*     */
  procedure UPDATE_RRPCONF_SECTIONS
  (
    NRN                     in number,   -- . 
    SCODE                   in varchar2, --  
    SNAME                   in varchar2  --  
  );
  
  /*     */
  procedure DELETE_RRPCONF_SECTIONS
  (
    NRN                     in number -- . 
  );
  
  /*      */
  procedure INSERT_RRPCONF_COLUMNROW
  (
    NPRN                    in number,   -- . 
    SCODE                   in varchar2, --   
    SNAME                   in varchar2, --   
    SCOLCODE                in varchar2, --  
    SCOLVER                 in varchar2, --   
    SROWCODE                in varchar2, --  
    SROWVER                 in varchar2, --   
    NRN                     out number   -- .  
  );
  
  /*      */
  procedure UPDATE_RRPCONF_COLUMNROW
  (
    NRN                     in number,  -- .              
    SNAME                   in varchar2 --  
  );
  
  /*      */
  procedure DELETE_RRPCONF_COLUMNROW
  (        
    NRN                     in number   -- .  
  );
  
  /*         */
  procedure GET_RRPCONFSCTNMRK_CODE_NAME
  ( 
    SSCTNCODE               in varchar2,  --    
    SROWCODE                in varchar2,  --  
    SCOLUMNCODE             in varchar2,  --  
    SCODE                   out varchar2, --   
    SNAME                   out varchar2  --       
  );

  /*     */
  procedure GET_RRPCONF_SECTIONS
  (
    NRN_RRPCONF             in number,  -- .    
    COUT                    out clob    --  
  );

end PKG_P8PANELS_RRPCONFED;
/
create or replace package body PKG_P8PANELS_RRPCONFED as

  /*     */
  procedure INSERT_RRPCONF_SECTIONS
  (
    NPRN                    in number,                             -- .    
    SCODE                   in varchar2,                           -- 
    SNAME                   in varchar2,                           -- 
    NRN                     out number                             -- .  
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- .  
  begin
    P_RRPCONFSCTN_INSERT(NCOMPANY            => NCOMPANY,
                         NPRN                => NPRN,
                         SCODE               => SCODE,
                         SNAME               => SNAME,
                         SRRPCONFSCTN        => null,
                         SRRPPRMGRP          => null,
                         SNOTE               => null,
                         NHTML_HIDE          => 0,
                         NHTML_HIDE_NAME_COL => 0,
                         NHTML_MAKE_HIER_GRP => 0,
                         SCLSF_CODE          => null,
                         NLINKS_UPDATE       => 0,
                         NDUP_RN             => null,
                         NRN                 => NRN);
  end INSERT_RRPCONF_SECTIONS;
  
  /*     */
  procedure UPDATE_RRPCONF_SECTIONS
  (
    NRN                     in number,                             -- . 
    SCODE                   in varchar2,                           --  
    SNAME                   in varchar2                            --  
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- .  
  begin
    P_RRPCONFSCTN_UPDATE(NRN                 => NRN,
                         NCOMPANY            => NCOMPANY,
                         SCODE               => SCODE,
                         SNAME               => SNAME,
                         SRRPCONFSCTN        => null,
                         SRRPPRMGRP          => null,
                         SNOTE               => null,
                         NHTML_HIDE          => 0,
                         NHTML_HIDE_NAME_COL => 0,
                         NHTML_MAKE_HIER_GRP => 0,
                         SCLSF_CODE          => null,
                         NFORMULA_UPDATE     => 0,
                         NMARK_UPDATE        => 0);
  end UPDATE_RRPCONF_SECTIONS;
  
  /*     */
  procedure DELETE_RRPCONF_SECTIONS
  (
    NRN                     in number                              -- . 
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- .  
  begin
    P_RRPCONFSCTN_DELETE(NRN => NRN, NCOMPANY => NCOMPANY);
  end DELETE_RRPCONF_SECTIONS;
  
  /*      */
  procedure INSERT_RRPCONF_COLUMNROW
  (
    NPRN                    in number,                             -- . 
    SCODE                   in varchar2,                           --   
    SNAME                   in varchar2,                           --   
    SCOLCODE                in varchar2,                           --  
    SCOLVER                 in varchar2,                           --   
    SROWCODE                in varchar2,                           --  
    SROWVER                 in varchar2,                           --   
    NRN                     out number                             -- .  
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- .  
    NCOUNT                  PKG_STD.TNUMBER;                       --   
  begin
    select count(*) into NCOUNT from RRPCONFSCTNMRK T where T.PRN = NPRN;
    P_RRPCONFSCTNMRK_INSERT(NCOMPANY           => NCOMPANY,
                            NPRN               => NPRN,
                            NNUMB              => NCOUNT + 1,
                            SCODE              => SCODE,
                            SNAME              => SNAME,
                            SRRPROW            => SROWCODE,
                            SRRPVERSION_ROW    => SROWVER,
                            SRRPCOLUMN         => SCOLCODE,
                            SRRPVERSION_COLUMN => SCOLVER,
                            SPKG_ROW           => null,
                            SPRC_ROW           => null,
                            SPKG_COL           => null,
                            SPRC_COL           => null,
                            SRRPPRM            => null,
                            NIGNORE_ZOOM       => 0,
                            NIGNORE_SHARP      => 0,
                            SCLSF_CODE         => null,
                            SNOTE              => null,
                            NDUP_RN            => null,
                            NRN                => NRN);
  end INSERT_RRPCONF_COLUMNROW;
  
  /*      */
  procedure UPDATE_RRPCONF_COLUMNROW
  (
    NRN                     in number,                             -- .              
    SNAME                   in varchar2                            --  
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- .  
    NNUMB                   PKG_STD.TNUMBER;                       --   
    SCODE                   PKG_STD.TSTRING;                       --   
    SCOLCODE                PKG_STD.TSTRING;                       --  
    SCOLVER                 PKG_STD.TSTRING;                       --   
    SROWCODE                PKG_STD.TSTRING;                       --  
    SROWVER                 PKG_STD.TSTRING;                       --   
  begin
    select T.NUMB,
           T.CODE,
           R.CODE,
           RVER.CODE,
           C.CODE,
           CVER.CODE
      into NNUMB,
           SCODE,
           SROWCODE,
           SROWVER,
           SCOLCODE,
           SCOLVER
      from RRPCONFSCTNMRK T,
           RRPCOLUMN      C,
           RRPVERSION     CVER,
           RRPROW         R,
           RRPVERSION     RVER
     where T.RN = NRN
       and T.RRPROW = R.RN(+)
       and R.RRPVERSION = RVER.RN(+)
       and T.RRPCOLUMN = C.RN(+)
       and C.RRPVERSION = CVER.RN(+);
    P_RRPCONFSCTNMRK_UPDATE(NRN                => NRN,
                            NCOMPANY           => NCOMPANY,
                            NNUMB              => NNUMB,
                            SCODE              => SCODE,
                            SNAME              => SNAME,
                            SRRPROW            => SROWCODE,
                            SRRPVERSION_ROW    => SROWVER,
                            SRRPCOLUMN         => SCOLCODE,
                            SRRPVERSION_COLUMN => SCOLVER,
                            SPKG_ROW           => null,
                            SPRC_ROW           => null,
                            SPKG_COL           => null,
                            SPRC_COL           => null,
                            SRRPPRM            => null,
                            NIGNORE_ZOOM       => 0,
                            NIGNORE_SHARP      => 0,
                            SCLSF_CODE         => null,
                            NFORMULA_UPDATE    => 0,
                            SNOTE              => null);
  end UPDATE_RRPCONF_COLUMNROW;
  
  /*      */
  procedure DELETE_RRPCONF_COLUMNROW
  (        
    NRN                     in number                              -- .  
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- .  
  begin
    P_RRPCONFSCTNMRK_DELETE(NCOMPANY => NCOMPANY, NRN => NRN);
  end DELETE_RRPCONF_COLUMNROW;
  
  /*         */
  procedure GET_RRPCONFSCTNMRK_CODE_NAME
  ( 
    SSCTNCODE               in varchar2,                           --    
    SROWCODE                in varchar2,                           --  
    SCOLUMNCODE             in varchar2,                           --  
    SCODE                   out varchar2,                          --   
    SNAME                   out varchar2                           --       
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- .  
    NROWRN                  PKG_STD.TREF;                          -- . 
    NCOLUMNRN               PKG_STD.TREF;                          -- . 
  begin
    P_RRPCONFSCTNMRK_MAKE_CODE(SRRPCONFSCTN => SSCTNCODE,
                               SRRPROW      => SROWCODE,
                               SRRPCOLUMN   => SCOLUMNCODE,
                               SCODE        => SCODE);
    select R.RN into NROWRN from RRPROW R where R.CODE = SROWCODE;
    select C.RN into NCOLUMNRN from RRPCOLUMN C where C.CODE = SCOLUMNCODE;
    P_RRPCONFSCTNMRK_MAKE_NAME(NCOMPANY            => NCOMPANY,
                               NRRPROW             => NROWRN,
                               NRRPCOLUMN          => NCOLUMNRN,
                               NCHANGE_NAME        => 1,
                               NCHANGE_NAME_PARENT => 0,
                               SNAME               => SNAME);
  end GET_RRPCONFSCTNMRK_CODE_NAME;

  /*     */
  procedure GET_RRPCONF_SECTIONS
  (
    NRN_RRPCONF             in number,                      -- .    
    COUT                    out clob                        --  
  )
  is
    NVERSION                PKG_STD.TREF;                   -- .        
    RDG                     PKG_P8PANELS_VISUAL.TDATA_GRID; --  
    RDG_ROW                 PKG_P8PANELS_VISUAL.TROW;       --  
    CDG                     clob;                           -- XML  
    CCURCLOB                clob;                           -- XML  
    NCURRN                  PKG_STD.TREF;                   -- .  
    SCURCODE                PKG_STD.TSTRING;                --   
    SCURNAME                PKG_STD.TSTRING;                --   
    SCUR_ROW                PKG_STD.TSTRING := 'default';   --   
    CXML                    PKG_CONTVALLOC2NS.TCONTAINER;   --    XML
    
    /*       .  */
    cursor C1 (NSCTN_RN in number) is
      select T.RN NRN, 
             T.PRN NPRN, 
             T.RRPCONF NRRPCONF, 
             T.RRPPRM NRRPPRM, 
             T.CODE SCODE, 
             T.NAME SNAME, 
             R.CODE SROW_CODE, 
             R.NAME SROW_NAME,
             C.CODE SCOLUMN_CODE,
             C.NAME SCOLUMN_NAME
        from RRPCONFSCTNMRK T,
             RRPROW         R,
             RRPCOLUMN      C
       where T.PRN in (select T2.RN 
                         from RRPCONFSCTN T2 
                        where T2.PRN = NRN_RRPCONF
                          and T2.VERSION = NVERSION)
         and T.VERSION = NVERSION
         and T.RRPROW = R.RN (+)
         and T.RRPCOLUMN = C.RN (+)
         and T.PRN = NSCTN_RN
       order by T.CODE;
    
    /*       .  */     
    cursor CN (NSCTN_RN in number) is
      select distinct(C.CODE) SCOLUMN_CODE, 
             C.NAME SCOLUMN_NAME
        from RRPCONFSCTNMRK T,
             RRPCOLUMN      C
       where T.PRN in (select T2.RN 
                         from RRPCONFSCTN T2 
                        where T2.PRN = NRN_RRPCONF
                          and T2.VERSION = NVERSION)
         and T.VERSION = NVERSION
         and T.RRPCOLUMN = C.RN (+)
         and T.PRN = NSCTN_RN
       order by SCOLUMN_CODE;
  begin
    /*   */
    PKG_CONTVALLOC2NS.PURGE(RCONTAINER => CXML);
    /*    */
    NVERSION := GET_SESSION_VERSION(SUNITCODE => 'RRPConfig');
    /*        */
    for C in (select T.RN      NRN,
                     T.VERSION NVERSION,
                     T.CRN     NCRN,
                     T.PRN     NPRN,
                     T.CODE    SCODE,
                     T.NAME    SNAME
                from RRPCONFSCTN T
               where T.PRN = NRN_RRPCONF
                 and T.VERSION = NVERSION)
    loop
      /*    */
      RDG := PKG_P8PANELS_VISUAL.TDATA_GRID_MAKE();
      /*    */
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                 SNAME      => 'SROW_NAME',
                                                 SCAPTION   => ' ',
                                                 SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR);
      /*      */
      for CL in CN(C.NRN)
      loop
        PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                   SNAME      => 'SCOL_' || CL.SCOLUMN_CODE,
                                                   SCAPTION   => CL.SCOLUMN_NAME,
                                                   SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR);
        PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                   SNAME      => 'NRN_' || CL.SCOLUMN_CODE,
                                                   SCAPTION   => CL.SCOLUMN_NAME || ' ',
                                                   SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                                   BVISIBLE   => false);
      end loop;
      /*        */
      SCUR_ROW := 'default';
      /*   */
      RDG_ROW := PKG_P8PANELS_VISUAL.TROW_MAKE();
      /*        */
      for CR in C1(C.NRN)
      loop
        /*    */
        if (SCUR_ROW != CR.SROW_CODE) then
          /*     */
          if (SCUR_ROW != 'default') then
            /*     */
            PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_ROW(RDATA_GRID => RDG, RROW => RDG_ROW);
            /*    */
            RDG_ROW := PKG_P8PANELS_VISUAL.TROW_MAKE();
          end if;
          /*     */
          SCUR_ROW := CR.SROW_CODE;
          /*    */
          PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SROW_NAME', SVALUE => CR.SROW_NAME);
        end if;
        /*     */
        PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SCOL_' || CR.SCOLUMN_CODE, SVALUE => CR.SNAME);
        /*  .   */
        PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NRN_' || CR.SCOLUMN_CODE, NVALUE => CR.NRN);
      end loop;
      /*      */
      PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_ROW(RDATA_GRID => RDG, RROW => RDG_ROW);
      /*   */
      CDG := PKG_P8PANELS_VISUAL.TDATA_GRID_TO_XML(RDATA_GRID => RDG, NINCLUDE_DEF => 1);
      /*      */
      PKG_CONTVALLOC2NS.PUTS(RCONTAINER => CXML, NTABID => C.NRN, SROWID => C.NRN || '_CODE', SVALUE => C.SCODE);
      PKG_CONTVALLOC2NS.PUTS(RCONTAINER => CXML, NTABID => C.NRN, SROWID => C.NRN || '_NAME', SVALUE => C.SNAME);
      PKG_CONTVALLOC2NS.PUTLC(RCONTAINER => CXML, NTABID => C.NRN, SROWID => C.NRN || '_CLOB', LCVALUE => CDG);
    end loop;
    /*  XML   */
    PKG_XFAST.PROLOGUE(ITYPE => PKG_XFAST.CONTENT_);
    PKG_XFAST.DOWN_NODE(SNAME => 'DATA');
    /*        */
    for X in 1 .. PKG_CONTVALLOC2NS.COUNT_(RCONTAINER => CXML)
    loop
      /* .  */
      if (X = 1) then
        NCURRN := PKG_CONTVALLOC2NS.FIRST_(RCONTAINER => CXML);
      else
        NCURRN := PKG_CONTVALLOC2NS.NEXT_(RCONTAINER => CXML, NTABID => NCURRN);
      end if;
      /*   */
      SCURCODE := PKG_CONTVALLOC2NS.GETS(RCONTAINER => CXML, NTABID => NCURRN, SROWID => NCURRN || '_CODE');
      /*   */
      SCURNAME := PKG_CONTVALLOC2NS.GETS(RCONTAINER => CXML, NTABID => NCURRN, SROWID => NCURRN || '_NAME');
      /* Clob    */
      CCURCLOB := PKG_CONTVALLOC2NS.GETLC(RCONTAINER => CXML, NTABID => NCURRN, SROWID => NCURRN || '_CLOB');
      /*   XML     */
      PKG_XFAST.DOWN_NODE(SNAME => 'SECTIONS');
      PKG_XFAST.ATTR(SNAME => 'NRN', NVALUE => NCURRN);
      PKG_XFAST.ATTR(SNAME => 'SCODE', SVALUE => SCURCODE);
      PKG_XFAST.ATTR(SNAME => 'SNAME', SVALUE => SCURNAME);
      PKG_XFAST.VALUE_XML(LCVALUE => CCURCLOB);
      PKG_XFAST.UP();
    end loop;
    PKG_XFAST.UP();
    /*   */
    COUT := PKG_XFAST.SERIALIZE_TO_CLOB();
    PKG_XFAST.EPILOGUE();
    /*   */
    PKG_CONTVALLOC2NS.PURGE(RCONTAINER => CXML);
  end GET_RRPCONF_SECTIONS;
  
end PKG_P8PANELS_RRPCONFED;
/
